Loading...
Searching...
No Matches
casacore::SPolynomialParam< T > Class Template Reference
scimath package (libcasa_scimath) » Functionals_module

More...

`#include <SPolynomialParam.h>`

## Public Member Functions

| SPolynomialParam ()
| Constructs a zero'th order polynomial, with a coeficcient of 0.0.
| SPolynomialParam (uInt order)
| Makes a polynomial of the given order, with all coeficcients set to zero.
| SPolynomialParam (const SPolynomialParam< T > &other)
| Make this a copy of other (deep copy).
template<class W>
| SPolynomialParam (const SPolynomialParam< W > &other)
SPolynomialParam< T > & | operator= (const SPolynomialParam< T > &other)
| ~SPolynomialParam ()
| Destructor.
Bool | operator== (const SPolynomialParam< T > &other) const
| Comparisons.
Bool | operator!= (const SPolynomialParam< T > &other) const
virtual const String & | name () const
| Give name of function.
uInt | order () const
| What is the order of the polynomial, i.e.
T | coefficient (uInt which) const
| What is the which'th coefficient of the polynomial.
Vector< T > | coefficients () const
| Return all the coefficients as a vector.
void | setCoefficient (uInt which, const T value)
| Set the which'th coefficient to value.
void | setCoefficients (const Vector< T > &coefficients)
| Set all the coefficients at once, throw away all existing coefficients.
virtual uInt | ndim () const
| Returns the dimension of function.
Public Member Functions inherited from casacore::Function< T, U >
| Function ()
| Constructors.
| Function (const uInt n)
| Function (const Vector< T > &in)
| Function (const FunctionParam< T > &other)
template<class W, class X>
| Function (const Function< W, X > &other)
virtual | ~Function ()
| Destructor.
uInt | nparameters () const
| Returns the number of parameters.
virtual U | eval (FunctionArg x) const =0
| Evaluate the function object.
T & | operator[] (const uInt n)
| Manipulate the nth parameter (0-based) with no index check.
const T & | operator[] (const uInt n) const
virtual U | operator() () const
| Evaluate this function object at xor at x, y.
virtual U | operator() (const ArgType &x) const
virtual U | operator() (const Vector< ArgType > &x) const
virtual U | operator() (FunctionArg x) const
virtual U | operator() (const ArgType &x, const ArgType &y) const
virtual U | operator() (const ArgType &x, const ArgType &y, const ArgType &z) const
Bool & | mask (const uInt n)
| Manipulate the mask associated with the nth parameter (e.g.
const Bool & | mask (const uInt n) const
const FunctionParam< T > & | parameters () const
| Return the parameter interface.
FunctionParam< T > & | parameters ()
const Vector< ArgType > & | argp () const
| Get arg_p and parset_p.
Bool | parsetp () const
void | lockParam ()
| Compiler cannot always find the correct 'const' version of parameter access.
void | unlockParam ()
virtual void | setMode (const RecordInterface &mode)
| get/set the function mode.
virtual void | getMode (RecordInterface &mode) const
virtual Bool | hasMode () const
| return True if the implementing function supports a mode.
ostream & | print (ostream &os) const
| Print the function (i.e.
virtual Function< T, U > * | clone () const =0
| Return a copy of this object from the heap.
virtual Function< typename FunctionTraits< T >::DiffType > * | cloneAD () const
virtual Function< typename FunctionTraits< T >::BaseType > * | cloneNonAD () const
Public Member Functions inherited from casacore::Functional< FunctionTraits< T >::ArgType, T >
virtual | ~Functional ()
| Destructor.
virtual T | operator() (const FunctionTraits< T >::ArgType &x) const=0
| Map a Domain x into a Range y value.
Public Member Functions inherited from casacore::Functional< Vector< FunctionTraits< T >::ArgType >, T >
virtual | ~Functional ()
| Destructor.
virtual T | operator() (const Vector< FunctionTraits< T >::ArgType > &x) const=0
| Map a Domain x into a Range y value.

## Additional Inherited Members

Public Types inherited from casacore::Function< T, U >
typedef FunctionTraits< T >::ArgType | ArgType
typedef const ArgType * | FunctionArg
Protected Attributes inherited from casacore::Function< T, U >
FunctionParam< T > | param_p
| The parameters and masks.
Vector< ArgType > | arg_p
| Aid for non-contiguous argument storage.
Bool | parset_p
| Indicate parameter written.
Bool | locked_p
| Indicate that parameters are expected to be locked from changing.

## Detailed Description

template<class T>
class casacore::SPolynomialParam< T >

Parameter handling for scaled 1-D polynomials

### Review Status

Test programs:
  tSPolynomial

### Prerequisite

- FunctionParam class
- Function

### Etymology

A 1-dimensional Scaled Polynomial's parameters.

### Synopsis

A SPolynomial is described by a set of coefficients; its fundamental operation is evaluating itself at some "x". The number of coefficients is the order of the polynomial plus one, plus three, describing a height, center and width. These three parameters are the first three, and have default values of 1, 0, 1.

Since the SPolynomial is a Function, the derivatives can be obtained as well.

The parameter interface (see FunctionParam class), is used to provide an interface to the Fitting classes.

This class is in general used implicitly by the SPolynomial class only.

### Example

SPolynomial<Float> pf(3); // Third order polynomial - coeffs 0 by default
pf.setCoefficient(1, 1.0);
pf[5] = 2.0;
pf.setCoefficient(3, 3.0); // 3x^3 + 2x^2 + x
pf(2); // == 34
casacore::SPolynomial
Definition SPolynomial.h:83

### Template Type Argument Requirements (T)

- T should have standard numerical operators. Current implementation only tested for real types (and their AutoDiffs).

### Thrown Exceptions

- Assertion in debug mode if attempt is made to address incorrect coefficients

### To Do

- Nothing I know of

Definition at line 97 of file SPolynomialParam.h.

## Constructor & Destructor Documentation

## SPolynomialParam() [1/4]

template<class T>

casacore::SPolynomialParam< T >::SPolynomialParam | ( |  | ) |

Constructs a zero'th order polynomial, with a coeficcient of 0.0.

Referenced by operator!=(), operator=(), operator==(), casacore::SPolynomial< T >::SPolynomial(), casacore::SPolynomial< T >::SPolynomial(), casacore::SPolynomial< T >::SPolynomial(), casacore::SPolynomial< T >::SPolynomial(), SPolynomialParam(), and SPolynomialParam().

## SPolynomialParam() [2/4]

template<class T>

casacore::SPolynomialParam< T >::SPolynomialParam | ( | uInt | order | ) |

explicit

Makes a polynomial of the given order, with all coeficcients set to zero.

References order().

## SPolynomialParam() [3/4]

template<class T>

casacore::SPolynomialParam< T >::SPolynomialParam | ( | const SPolynomialParam< T > & | other | ) |

Make this a copy of other (deep copy).

References SPolynomialParam().

## SPolynomialParam() [4/4]

template<class T>
template<class W>

casacore::SPolynomialParam< T >::SPolynomialParam | ( | const SPolynomialParam< W > & | other | ) |

inline

Definition at line 112 of file SPolynomialParam.h.

References casacore::Function< T, U >::Function(), and SPolynomialParam().

## ~SPolynomialParam()

template<class T>

casacore::SPolynomialParam< T >::~SPolynomialParam | ( |  | ) |

Destructor.

## Member Function Documentation

## coefficient()

template<class T>

T casacore::SPolynomialParam< T >::coefficient | ( | uInt | which | ) | const

inline

What is the which'th coefficient of the polynomial.

For an nth degree polynomial, which varies between zero and n.

Definition at line 140 of file SPolynomialParam.h.

References DebugAssert, order(), and casacore::Function< T, U >::param_p.

## coefficients()

template<class T>

Vector< T > casacore::SPolynomialParam< T >::coefficients | ( |  | ) | const

Return all the coefficients as a vector.

Referenced by setCoefficients().

## name()

template<class T>

virtual const String & casacore::SPolynomialParam< T >::name | ( |  | ) | const

inline virtual

Give name of function.

Reimplemented from casacore::Function< T, U >.

Definition at line 132 of file SPolynomialParam.h.

## ndim()

template<class T>

virtual uInt casacore::SPolynomialParam< T >::ndim | ( |  | ) | const

inline virtual

Returns the dimension of function.

Implements casacore::Function< T, U >.

Definition at line 154 of file SPolynomialParam.h.

## operator!=()

template<class T>

Bool casacore::SPolynomialParam< T >::operator!= | ( | const SPolynomialParam< T > & | other | ) | const

inline

Definition at line 126 of file SPolynomialParam.h.

References casacore::Function< T, U >::param_p, and SPolynomialParam().

## operator=()

template<class T>

SPolynomialParam< T > & casacore::SPolynomialParam< T >::operator= | ( | const SPolynomialParam< T > & | other | ) |

References SPolynomialParam().

Referenced by casacore::SPolynomial< T >::operator=().

## operator==()

template<class T>

Bool casacore::SPolynomialParam< T >::operator== | ( | const SPolynomialParam< T > & | other | ) | const

inline

Comparisons.

SPolynomials are equal if they are of the same order

Definition at line 124 of file SPolynomialParam.h.

References casacore::Function< T, U >::param_p, and SPolynomialParam().

## order()

template<class T>

uInt casacore::SPolynomialParam< T >::order | ( |  | ) | const

inline

What is the order of the polynomial, i.e.

maximum exponent of "x".

Definition at line 136 of file SPolynomialParam.h.

References casacore::Function< T, U >::param_p.

Referenced by coefficient(), setCoefficient(), casacore::SPolynomial< T >::SPolynomial(), and SPolynomialParam().

## setCoefficient()

template<class T>

void casacore::SPolynomialParam< T >::setCoefficient | ( | uInt | which,
|  | const T | value )

inline

Set the which'th coefficient to value.

Definition at line 147 of file SPolynomialParam.h.

References DebugAssert, casacore::NewDelAllocator< T >::value, order(), and casacore::Function< T, U >::param_p.

## setCoefficients()

template<class T>

void casacore::SPolynomialParam< T >::setCoefficients | ( | const Vector< T > & | coefficients | ) |

Set all the coefficients at once, throw away all existing coefficients.

References coefficients().

The documentation for this class was generated from the following file:

- scimath/Functionals/SPolynomialParam.h